/*
 * generated by Xtext
 */
package es.uca.webservices.testgen.parsers.spec.xtext.ui.outline;

import org.eclipse.swt.graphics.Image;
import org.eclipse.xtext.ui.editor.outline.impl.DefaultOutlineTreeProvider;
import org.eclipse.xtext.ui.editor.outline.impl.DocumentRootNode;
import org.eclipse.xtext.ui.editor.outline.impl.EStructuralFeatureNode;

import es.uca.webservices.testgen.parsers.spec.xtext.testSpec.Entry;
import es.uca.webservices.testgen.parsers.spec.xtext.testSpec.Model;
import es.uca.webservices.testgen.parsers.spec.xtext.testSpec.TestSpecPackage;
import es.uca.webservices.testgen.parsers.spec.xtext.testSpec.Variable;
import es.uca.webservices.testgen.parsers.spec.xtext.testSpec.VariableList;
import es.uca.webservices.testgen.parsers.spec.xtext.testSpec.impl.StrategyImpl;
import es.uca.webservices.testgen.parsers.spec.xtext.testSpec.impl.TypedefImpl;
import es.uca.webservices.testgen.parsers.spec.xtext.testSpec.impl.VariableListImpl;

/**
 * customization of the default outline structure
 * 
 */
public class TestSpecOutlineTreeProvider extends DefaultOutlineTreeProvider {

	protected void _createChildren(DocumentRootNode parentNode,
			Model domainmodel) {

		final Image nullImage = null;

		final EStructuralFeatureNode virtualTypedef = createEStructuralFeatureNode(
				parentNode, domainmodel,
				TestSpecPackage.Literals.MODEL__ENTRIES, nullImage, "Typedefs",
				true);
		for (Entry element : domainmodel.getEntries()) {
			if (element.getClass() == TypedefImpl.class)
				createNode(virtualTypedef, element);
		}
		final EStructuralFeatureNode virtualVariable = createEStructuralFeatureNode(
				parentNode, domainmodel,
				TestSpecPackage.Literals.MODEL__ENTRIES, nullImage, "Declarations",
				true);
		for (Entry element : domainmodel.getEntries()) {
			if (element.getClass() == VariableListImpl.class){
				for(Variable v : ((VariableList)element).getVars()){
					createNode(virtualVariable, v);
				}
			}
		}
		final EStructuralFeatureNode virtualStrategy = createEStructuralFeatureNode(
				parentNode, domainmodel,
				TestSpecPackage.Literals.MODEL__ENTRIES, nullImage, "Strategies",
				true);
		for (Entry element : domainmodel.getEntries()) {
			if (element.getClass() == StrategyImpl.class)
				createNode(virtualStrategy, element);
		}

	}
}
